//---------------------------------------------------------------------------
#include <algorithm>
#include "QUndoRemove.h"
//---------------------------------------------------------------------------
QUndoRemove::QUndoRemove(void) {}
//---------------------------------------------------------------------------
QUndoRemove::QUndoRemove(QCircuit *qc) {
  Add(qc);
}
//---------------------------------------------------------------------------
QUndoRemove::~QUndoRemove(void) {
  for (QList::iterator qc=qList.begin();qc!=qList.end();qc++) {
    delete (*qc);
  }
}
//---------------------------------------------------------------------------
void
QUndoRemove::Add(QCircuit *qc) {
  qList.push_back(qc->Clone());
}
//---------------------------------------------------------------------------
/**
 * Undo
 */
void
QUndoRemove::Undo(QManager *qManager) {
  for (QList::iterator qc=qList.begin();qc!=qList.end();qc++) {
    qManager->Add(*qc);
  }
}
//---------------------------------------------------------------------------

